## bladerf 0.10.7.47.ebe70c4

=== host/libraries/libbladeRF/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.5)
project(libbladeRF C)

if(MSVC)
    find_package(LibPThreadsWin32 REQUIRED)
    if(LIBPTHREADSWIN32_FOUND)
        set(HAVE_THREADS true)
    else()
        set(HAVE_THREADS false)
    endif()
else(MSVC)
    find_package(Threads REQUIRED)
    if(Threads_FOUND)
        set(HAVE_THREADS true)
    else()
        set(HAVE_THREADS false)
    endif()
endif(MSVC)

################################################################################
# Version information
################################################################################

set(VERSION_INFO_MAJOR  0)
set(VERSION_INFO_MINOR  14)
set(VERSION_INFO_PATCH  0)

if(NOT DEFINED VERSION_INFO_EXTRA)
    set(VERSION_INFO_EXTRA "git")
endif()
include(Version)

set(VERSION "${VERSION_INFO}")
set(LIBVER "${VERSION_INFO_BASE}")

configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/src/version.h.in
    ${CMAKE_CURRENT_BINARY_DIR}/src/version.h
    @ONLY
)

if(MSVC)
    configure_file(
        ${CMAKE_CURRENT_SOURCE_DIR}/bladerf.rc.in
        ${CMAKE_CURRENT_BINARY_DIR}/bladerf.rc
        @ONLY
    )
endif()


include(GNUInstallDirs)

# Fall back to just "lib" if the item provided by GNUInstallDirs doesn't exist
# For example, on Ubuntu 13.10 with CMake 2.8.11.2,
# /usr/lib/${CMAKE_LIBRARY_ARCHITECTURE} doesn't exist.
if (NOT EXISTS "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}")
    message(STATUS "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR} does not exist. Defaulting libbladeRF install location to ${CMAKE_INSTALL_PREFIX}/lib.")
    set(CMAKE_INSTALL_LIBDIR lib)
endif()

################################################################################
# Configuration options
################################################################################

option(ENABLE_LIBBLADERF_LOGGING "Enable log messages in libbladeRF." ON)

option(BUILD_LIBBLADERF_DOCUMENTATION "Build libbladeRF documentation. Requries Doxygen." ${BUILD_DOCUMENTATION})
if(NOT ${BUILD_DOCUMENTATION})
    set(BUILD_LIBBLADERF_DOCUMENTATION OFF)
endif()

##############################
# Backend Support
##############################
option(ENABLE_BACKEND_LIBUSB "Enable libusb backend support."
    ON
)

option(ENABLE_BACKEND_DUMMY "Enable dummy backend support. This is only useful for some developers."
    OFF
)

option(LIBUSB_DETACH_KERNEL_DRIVER
    "Enable calls to libusb_detach_kernel_driver(). Not supported in Windows."
    ON
)

option(ENABLE_LIBBLADERF_SYNC
    "Enable the libbladeRF synchronous data interface. Requires pthreads."
    ON
)

option(ENABLE_LIBBLADERF_SYNC_LOG_VERBOSE
      "Enable log_verbose() calls in the sync interface's data path. Note that this may harm performance."
      OFF
)


option(ENABLE_BACKEND_LINUX_DRIVER
    "Enable Linux driver backend support."
    OFF
)

# Ensure we've got at least one backend enabled
if(NOT ENABLE_BACKEND_LIBUSB AND NOT ENABLE_BACKEND_LINUX_DRIVER AND NOT ENABLE_BACKEND_DUMMY)
    message(FATAL_ERROR
            "No libbladeRF backends are enabled. "
            "Please enable one or more backends." )
endif()

configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/src/backend_config.h.in
    ${CMAKE_CURRENT_BINARY_DIR}/src/backend_config.h
    @ONLY
)

################################################################################
# Additional compiler options
################################################################################
if(ENABLE_LIBBLADERF_LOGGING)
    add_definitions(-DLOGGING_ENABLED)
endif()


if("${CMAKE_C_COMPILER_ID}" STREQUAL "GNU" OR
    "${CMAKE_C_COMPILER_ID}" STREQUAL "Clang" )

    # Doing this manually instead of via add_compiler_export_flags() since
    # the GenerateExportHeader module appears to break for C-only projects:
    #
    # http://www.cmake.org/pipermail/cmake-commits/2012-August/013142.html
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fvisibility=hidden")
endif()

################################################################################
# Include paths
################################################################################
set(LIBBLADERF_INCLUDES
    ${CMAKE_CURRENT_SOURCE_DIR}/include
    ${CMAKE_CURRENT_SOURCE_DIR}/src
    ${BLADERF_HOST_COMMON_INCLUDE_DIRS}
    ${BLADERF_FW_COMMON_INCLUDE_DIR}
    ${CMAKE_CURRENT_BINARY_DIR}/src
)

################################################################################
# Build dependencies
################################################################################
if(NOT HAVE_THREADS)
    message(FATAL_ERROR "Pthreads is required for libbladeRF")
endif()

if(ENABLE_BACKEND_LIBUSB)
    find_package(LibUSB)
    if(NOT LIBUSB_FOUND)
        message(FATAL_ERROR "libusb-1.0 not found. This is required to use the libbladeRF libusb backend. For binary releases, try setting LIBUSB_PATH.")
    else(NOT LIBUSB_FOUND)
        if(LIBUSB_HAVE_GET_VERSION)
            add_definitions(-DHAVE_LIBUSB_GET_VERSION)
        endif(LIBUSB_HAVE_GET_VERSION)

        set(LIBBLADERF_INCLUDES ${LIBBLADERF_INCLUDES} ${LIBUSB_INCLUDE_DIRS})
    endif(NOT LIBUSB_FOUND)
endif(ENABLE_BACKEND_LIBUSB)

if(ENABLE_LIBBLADERF_SYNC)
    if(MSVC)
        set(LIBBLADERF_INCLUDES ${LIBBLADERF_INCLUDES}
            ${LIBPTHREADSWIN32_INCLUDE_DIRS})
    endif()

    add_definitions(-DENABLE_LIBBLADERF_SYNC)

    if(ENABLE_LIBBLADERF_SYNC_LOG_VERBOSE AND ENABLE_LIBBLADERF_LOGGING)
        add_definitions(-DENABLE_LIBBLADERF_SYNC_LOG_VERBOSE)
    endif()
endif(ENABLE_LIBBLADERF_SYNC)

include_directories(${LIBBLADERF_INCLUDES})

################################################################################
# Configure source files
################################################################################
set(LIBBLADERF_SOURCE
        src/async.c
        src/backend.c
        src/bladerf.c
        src/bladerf_priv.c
        src/file_ops.c
        src/lms.c
        src/si5338.c
        src/version.h
        src/device_identifier.c
        src/devinfo.c
        src/flash.c
        src/image.c
        ${BLADERF_HOST_COMMON_SOURCE_DIR}/sha256.c
        ${BLADERF_HOST_COMMON_SOURCE_DIR}/conversions.c
        ${BLADERF_HOST_COMMON_SOURCE_DIR}/log.c
)

if (MSVC)
        set(LIBBLADERF_SOURCE ${LIBBLADERF_SOURCE} ${CMAKE_CURRENT_BINARY_DIR}/bladerf.rc)
endif()

if(LIBUSB_FOUND AND ENABLE_BACKEND_LIBUSB)
    set(LIBBLADERF_SOURCE ${LIBBLADERF_SOURCE} src/backend/libusb.c)
endif()

if(ENABLE_BACKEND_DUMMY)
    set(LIBBLADERF_SOURCE ${LIBBLADERF_SOURCE} src/backend/dummy.c)
endif()

if(ENABLE_BACKEND_LINUX_DRIVER)
    set(LIBBLADERF_SOURCE ${LIBBLADERF_SOURCE} src/backend/linux.c)
endif()

if(ENABLE_LIBBLADERF_SYNC)
    set(LIBBLADERF_SOURCE ${LIBBLADERF_SOURCE}
        src/sync.c
        src/sync_worker.c
    )

    if(BLADERF_OS_OSX)
       set(LIBBLADERF_SOURCE ${LIBBLADERF_SOURCE}
           ${BLADERF_HOST_COMMON_SOURCE_DIR}/osx/clock_gettime.c
       )
    endif()

    if(MSVC)
        set(LIBBLADERF_SOURCE ${LIBBLADERF_SOURCE}
            ${BLADERF_HOST_COMMON_SOURCE_DIR}/windows/clock_gettime.c
        )
    endif()
endif()

add_library(libbladerf_shared SHARED ${LIBBLADERF_SOURCE})

################################################################################
# Build configuration
################################################################################

if(ENABLE_LIBBLADERF_SYNC)
    if(MSVC)
        set(LIBBLADERF_LIBS ${LIBBLADERF_LIBS} ${LIBPTHREADSWIN32_LIBRARIES})
    else()
        set(LIBBLADERF_LIBS ${LIBBLADERF_LIBS} ${CMAKE_THREAD_LIBS_INIT})
    endif(MSVC)
endif()

if(ENABLE_BACKEND_LIBUSB)
    set(LIBBLADERF_LIBS ${LIBBLADERF_LIBS} ${LIBUSB_LIBRARIES})
endif()

target_link_libraries(libbladerf_shared ${LIBBLADERF_LIBS})

# Adjust our output name
set_target_properties(libbladerf_shared PROPERTIES OUTPUT_NAME bladeRF)

# Set shared library version
set_target_properties(libbladerf_shared PROPERTIES SOVERSION ${VERSION_INFO_MAJOR})


################################################################################
# Generate pkg-config file
################################################################################
add_subdirectory(include)
foreach(inc ${LIBBLADERF_INCLUDE_DIR})
    list(APPEND LIBBLADERF_PC_CFLAGS "-I${inc}")
endforeach()

foreach(lib ${LIBBLADERF_LIBRARY_DIRS})
    list(APPEND LIBBLADERF_PC_PRIV_LIBS "-L${lib}")
endforeach()

set(LIBBLADERF_PC_PREFIX ${CMAKE_INSTALL_PREFIX})
set(LIBBLADERF_PC_EXEC_PREFIX \${prefix})
set(LIBBLADERF_PC_LIBDIR \${exec_prefix}/${CMAKE_INSTALL_LIBDIR})
set(LIBBLADERF_PC_INCLUDEDIR \${prefix}/include)
set(LIBBLADERF_PC_VERSION ${VERSION})
set(LIBBLADERF_PC_LIBS "-lbladeRF")

# Use space-delimiter in the .pc file, rather than CMake's semicolon separator
string(REPLACE ";" " " LIBBLADERF_PC_CFLAGS "${LIBBLADERF_PC_CFLAGS}")
string(REPLACE ";" " " LIBBLADERF_PC_LIBS "${LIBBLADERF_PC_LIBS}")

# Unset these to avoid hard-coded paths in a cross-environment
if(CMAKE_CROSSCOMPILING)
    unset(LIBBLADERF_PC_CFLAGS)
    unset(LIBBLADERF_PC_LIBS)
endif()

configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/libbladeRF.pc.in
    ${CMAKE_CURRENT_BINARY_DIR}/libbladeRF.pc
    @ONLY
)

install(
    FILES ${CMAKE_CURRENT_BINARY_DIR}/libbladeRF.pc
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig/
)

################################################################################
# Library installation information
################################################################################
install(TARGETS libbladerf_shared
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR} # .so/.dylib
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR} # .a/.lib
    RUNTIME DESTINATION ${CMAKE_INSTALL_LIBDIR} # .dll
)


################################################################################
# Informational output
################################################################################
message(STATUS "libbladeRF version: ${VERSION_INFO}")

################################################################################
# Library tests
################################################################################
add_subdirectory(tests)

################################################################################
# Doxygen documentation
################################################################################
if(BUILD_LIBBLADERF_DOCUMENTATION)
    find_package(Doxygen)
    if(DOXYGEN_FOUND)
        message(STATUS "Configured to build libbladeRF API documentation.")
        configure_file(
            ${CMAKE_CURRENT_SOURCE_DIR}/doc/doxygen/Doxyfile.in
            ${CMAKE_CURRENT_BINARY_DIR}/doc/doxygen/Doxyfile
            @ONLY
            )

        add_custom_command(
            OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/doc/doxygen/html/index.html
            DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/doc/doxygen/Doxyfile ${CMAKE_CURRENT_SOURCE_DIR}/include/libbladeRF.h
            COMMAND ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/doc/doxygen/Doxyfile
            WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/doc/doxygen
            COMMENT "Generating libbladeRF API documentation via Doxygen in: ${CMAKE_CURRENT_BINARY_DIR}/doc/doxygen"
        )

    add_custom_target(libbladeRF-doxygen ALL DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/doc/doxygen/html/index.html)

    else(DOXYGEN_FOUND)
        message(WARNING "Could not find Doxygen. libbladeRF API documentation will not be built.")
    endif(DOXYGEN_FOUND)
endif(BUILD_LIBBLADERF_DOCUMENTATION)

=== host/utilities/bladeRF-cli/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
project(bladeRF-cli C)

################################################################################
# Version information
################################################################################

set(VERSION_INFO_MAJOR  0)
set(VERSION_INFO_MINOR  10)
set(VERSION_INFO_PATCH  7)
if(NOT DEFINED VERSION_INFO_EXTRA)
    set(VERSION_INFO_EXTRA "git")
endif()
include(Version)

set(VERSION "${VERSION_INFO}")

configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/src/version.h.in
    ${CMAKE_CURRENT_BINARY_DIR}/src/version.h
    @ONLY
)

################################################################################
# Build dependencies
################################################################################
find_package(LibTecla)
find_package(LibUSB)

if(MSVC)
    find_package(LibPThreadsWin32 REQUIRED)
else(MSVC)
	find_package(Threads REQUIRED)
endif(MSVC)

################################################################################
# Configuration options
################################################################################

option(ENABLE_LIBTECLA
        "Enable the use of libtecla, if available."
        ${LIBTECLA_FOUND}
)

option(BUILD_BLADERF_CLI_DOCUMENTATION
        "Build bladeRF-cli man page. Requires help2man and python."
        ${BUILD_DOCUMENTATION})

if(NOT ${BUILD_DOCUMENTATION})
    set(BUILD_BLADERF_CLI_DOCUMENTATION OFF)
endif()


if(ENABLE_LIBTECLA)
    message(STATUS "libtecla support enabled")
endif()

################################################################################
# Include paths
################################################################################
set(CLI_INCLUDE_DIRS
       ${CMAKE_CURRENT_SOURCE_DIR}/src
       ${CMAKE_CURRENT_SOURCE_DIR}/src/cmd
       ${CMAKE_CURRENT_SOURCE_DIR}/src/interactive
       ${CMAKE_CURRENT_BINARY_DIR}/src
       ${BLADERF_HOST_COMMON_INCLUDE_DIRS}
       ${libbladeRF_SOURCE_DIR}/include
       ${BLADERF_FW_COMMON_INCLUDE_DIR}
       ${UTILITIES_COMMON_INC_DIR}
)


if(ENABLE_LIBTECLA)
    set(CLI_INCLUDE_DIRS ${CLI_INCLUDE_DIRS} ${LIBTECLA_INCLUDE_DIR})
endif()

if(LIBUSB_FOUND)
    set(CLI_INCLUDE_DIRS ${CLI_INCLUDE_DIRS} ${LIBUSB_INCLUDE_DIRS})
endif()

if(MSVC)
    set(CLI_INCLUDE_DIRS ${CLI_INCLUDE_DIRS}
        ${BLADERF_HOST_COMMON_INCLUDE_DIRS}/windows
        ${LIBPTHREADSWIN32_INCLUDE_DIRS}
    )
endif()

if(APPLE)
    set(CLI_INCLUDE_DIRS ${CLI_INCLUDE_DIRS}
        ${BLADERF_HOST_COMMON_INCLUDE_DIRS}/osx
    )
endif()

include_directories(${CLI_INCLUDE_DIRS})

################################################################################
# Configure source files
################################################################################
set(BLADERF_CLI_SOURCE
        src/main.c
        src/common.c
        src/script.c
        src/cmd/calibrate.c
        src/cmd/cmd.c
        src/cmd/erase.c
        src/cmd/flash_common.c
        src/cmd/flash_backup.c
        src/cmd/flash_image.c
        src/cmd/flash_init_cal.c
        src/cmd/flash_restore.c
        src/cmd/info.c
        src/cmd/load.c
        src/cmd/open.c
        src/cmd/peek.c
        src/cmd/peekpoke.c
        src/cmd/poke.c
        src/cmd/printset.c
        src/cmd/probe.c
        src/cmd/rx.c
        src/cmd/rxtx.c
        src/cmd/tx.c
        src/cmd/version.c
        src/cmd/jump_boot.c
        src/cmd/mimo.c
        src/cmd/correct.c
        src/interactive/interactive.c
        ${BLADERF_HOST_COMMON_SOURCE_DIR}/conversions.c
        ${BLADERF_HOST_COMMON_SOURCE_DIR}/log.c
)

if(LIBUSB_FOUND)
  set(BLADERF_CLI_SOURCE ${BLADERF_CLI_SOURCE}
          src/cmd/recover.c
          ${UTILITIES_COMMON_SRC}/ezusb.c
)
endif()

# Select the interactive mode (and script handling) backend
if(ENABLE_LIBTECLA)
    set(BLADERF_CLI_SOURCE ${BLADERF_CLI_SOURCE} src/interactive/tecla.c)
else()
    set(BLADERF_CLI_SOURCE ${BLADERF_CLI_SOURCE} src/interactive/fgets.c)
endif()

if(MSVC)
    set(BLADERF_CLI_SOURCE ${BLADERF_CLI_SOURCE}
            ${BLADERF_HOST_COMMON_SOURCE_DIR}/windows/getopt_long.c
            ${BLADERF_HOST_COMMON_SOURCE_DIR}/windows/clock_gettime.c
    )
endif()

if(APPLE)
    set(BLADERF_CLI_SOURCE ${BLADERF_CLI_SOURCE}
            ${BLADERF_HOST_COMMON_SOURCE_DIR}/osx/clock_gettime.c
    )
endif()

add_executable(bladeRF-cli ${BLADERF_CLI_SOURCE})

################################################################################
# Build configuration
################################################################################
set(CLI_LINK_LIBRARIES
    libbladerf_shared
    ${CMAKE_THREAD_LIBS_INIT}
)

if(ENABLE_LIBTECLA)
    set(CLI_LINK_LIBRARIES ${CLI_LINK_LIBRARIES} ${LIBTECLA_LIBRARIES})

    # On a few tests Linux distros, libtecla is not build against
    # ncurses. However, folks have reported that builds on OSX use it
    if(CMAKE_HOST_APPLE)
        set(CLI_LINK_LIBRARIES ${CLI_LINK_LIBRARIES} ncurses)
    endif(CMAKE_HOST_APPLE)

endif(ENABLE_LIBTECLA)

if(LIBUSB_FOUND)
    add_definitions(-DCLI_LIBUSB_ENABLED)
    set(CLI_LINK_LIBRARIES ${CLI_LINK_LIBRARIES} ${LIBUSB_LIBRARIES})
endif()

if(LIBPTHREADSWIN32_FOUND)
    set(CLI_LINK_LIBRARIES ${CLI_LINK_LIBRARIES} ${LIBPTHREADSWIN32_LIBRARIES})
endif()

if(LIBC_VERSION)
    # clock_gettime() was moved from librt -> libc in 2.17
    if(${LIBC_VERSION} VERSION_LESS "2.17")
        set(CLI_LINK_LIBRARIES ${CLI_LINK_LIBRARIES} rt)
    endif()
endif()

target_link_libraries(bladeRF-cli ${CLI_LINK_LIBRARIES})

################################################################################
# Man pages
################################################################################
if(BUILD_BLADERF_CLI_DOCUMENTATION)
    find_program(HELP2MAN_EXECUTABLE help2man)

    if(HELP2MAN_EXECUTABLE)
        message(STATUS "Will build man page for bladeRF-cli.")

        if(NOT DEFINED MAN_INSTALL_DIR)
            set(MAN_INSTALL_DIR share/man)
        endif(NOT DEFINED MAN_INSTALL_DIR)

        # Build interactive commands summary, for inclusion in man page
        add_custom_command(
            OUTPUT bladeRF-cli_auto.h2m
            DEPENDS bladeRF-cli
            COMMAND python ${CMAKE_CURRENT_SOURCE_DIR}/../doc/include_man/interrogate.py
                           ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/bladeRF-cli > bladeRF-cli_auto.h2m
            WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
        )

        # Build actual man page
        add_custom_command(
            OUTPUT bladeRF-cli.1
            DEPENDS bladeRF-cli bladeRF-cli_auto.h2m
            COMMAND ${HELP2MAN_EXECUTABLE} --no-info
                                           --opt-include=${CMAKE_CURRENT_SOURCE_DIR}/../doc/include_man/bladeRF-cli.h2m
                                           --opt-include=${CMAKE_CURRENT_BINARY_DIR}/bladeRF-cli_auto.h2m
                                           --opt-include=${CMAKE_CURRENT_SOURCE_DIR}/../doc/include_man/common.h2m
                                           --output=bladeRF-cli.1 ./bladeRF-cli
            WORKING_DIRECTORY ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}
        )

        install(FILES ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/bladeRF-cli.1 DESTINATION ${MAN_INSTALL_DIR}/man1)

        add_custom_target(bladeRF-cli-manpage ALL DEPENDS bladeRF-cli.1)

    else(HELP2MAN_EXECUTABLE)
        message(WARNING "Could not find help2man. bladeRF-cli man page will not be built.")
    endif(HELP2MAN_EXECUTABLE)
else(BUILD_BLADERF_CLI_DOCUMENTATION)
    message(STATUS "Not building man page for bladeRF-cli.  (BUILD_BLADERF_CLI_DOCUMENTATION is OFF)")
endif(BUILD_BLADERF_CLI_DOCUMENTATION)

################################################################################
# Installation
################################################################################
if(NOT DEFINED BIN_INSTALL_DIR)
    set(BIN_INSTALL_DIR bin)
endif()

install(TARGETS bladeRF-cli DESTINATION ${BIN_INSTALL_DIR})

################################################################################
# Informational output
################################################################################
message(STATUS "Configured to build bladeRF-cli version: ${VERSION_INFO}")

=== host/libraries/libbladeRF/tests/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
add_subdirectory(test_async)
add_subdirectory(test_sync)
add_subdirectory(test_repeater)

=== debian/changelog ===
bladerf (0.10.7.47.ebe70c4-4) unstable; urgency=low

  * avoid help2man build failures on some architectures

 -- A. Maitland Bottoms <bottoms@debian.org>  Sat, 19 Apr 2014 19:07:28 -0400

bladerf (0.10.7.47.ebe70c4-3) unstable; urgency=low

  * More kFreeBSD build fixes

 -- A. Maitland Bottoms <bottoms@debian.org>  Fri, 18 Apr 2014 18:53:19 -0400

bladerf (0.10.7.47.ebe70c4-2) unstable; urgency=low

  * Find libusb2 library on kFreeBSD

 -- A. Maitland Bottoms <bottoms@debian.org>  Sun, 13 Apr 2014 17:10:54 -0400

bladerf (0.10.7.47.ebe70c4-1) unstable; urgency=low

  * Update to v0.10.7 47 ebe70c4

 -- A. Maitland Bottoms <bottoms@debian.org>  Sun, 13 Apr 2014 11:35:00 -0400

bladerf (0.9.0.15.8ba2499-1~bpo70+1) wheezy-backports; urgency=low

  * Rebuild for wheezy-backports.

 -- A. Maitland Bottoms <bottoms@debian.org>  Tue, 21 Jan 2014 20:53:21 -0500

=== debian/control ===
Source: bladerf
Section: comm
Priority: optional
Maintainer: A. Maitland Bottoms <bottoms@debian.org>
Build-Depends: debhelper (>= 9), cmake, pkg-config, libusb-1.0-0-dev,
 libtecla1-dev, libncurses5-dev, python, help2man [amd64 i386], doxygen
Standards-Version: 3.9.5
Homepage: http://nuand.com/bladeRF
Vcs-Browser: https://github.com/Nuand/bladeRF
Vcs-Git: https://github.com/Nuand/bladeRF.git

Package: bladerf-host
Architecture: any
Multi-Arch: foreign
Depends: libbladerf0 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}, adduser
Recommends: python-tk, curl, procps, udev
Suggests: gnuradio
Description: nuand bladeRF software-defined radio device (tools)
 Host utilities for nuand BladeRF USB 3.0 Superspeed Software Defined Radio.
 .
 The nuand bladeRF is an open-source software-defined radio (SDR) system,
 comprised of an RF transceiver, a field-programmable gate array (FPGA),
 a microcontroller driving a USB 3.0 interface, and a suite of host
 libraries and drivers to facilitate interaction with the device.
 .
 This package includes the command-line tools to locate and configure
 attached peripherals, to display hardware configuration
 information, and control the bladeRF.

Package: libbladerf0
Architecture: any
Section: libs
Pre-Depends: multiarch-support, ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: gnuradio
Multi-Arch: same
Description: nuand bladeRF software-defined radio device (host library)
 Host library for nuand BladeRF USB 3.0 Superspeed Software Defined Radio.
 .
 The nuand bladeRF is an open-source software-defined radio (SDR) system,
 comprised of an RF transceiver, a field-programmable gate array (FPGA),
 a microcontroller driving a USB 3.0 interface, and a suite of host
 libraries and drivers to facilitate interaction with the device.
 .
 This package provides the host library.

Package: libbladerf-dev
Architecture: any
Section: libdevel
Multi-Arch: same
Depends: libbladerf0 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Suggests: libjs-jquery, gnuradio
Description: nuand bladeRF software-defined radio device (header files)
 Development files for nuand BladeRF USB 3.0 Superspeed Software Defined Radio.
 .
 The nuand bladeRF is an open-source software-defined radio (SDR) system,
 comprised of an RF transceiver, a field-programmable gate array (FPGA),
 a microcontroller driving a USB 3.0 interface, and a suite of host
 libraries and drivers to facilitate interaction with the device.
 .
 This package contains the header files required for compiling bladeRF
 applications.

=== debian/rules ===
#!/usr/bin/make -f
DEB_DEBIAN_DIR=$(dir $(firstword $(MAKEFILE_LIST)))
VER=$(shell dpkg-parsechangelog -l$(DEB_DEBIAN_DIR)/changelog \
              | sed -rne 's,^Version: ([^-]+).*,\1,p')
GITREV=$(shell echo $(VER) | sed -rne 's,[0-9]+\.[0-9]+\.[0-9]+\.[0-9]+\.([0-f]+),\1,p')

%:
	dh $@ --parallel --sourcedirectory=host --builddirectory=build

override_dh_auto_configure: debian/bladerf-host.udev
	dh_auto_configure --sourcedirectory=host --builddirectory=build -- -DVERSION_INFO_OVERRIDE:STRING=$(VER)

get-orig-source:
	git clone https://github.com/Nuand/bladeRF.git
	cd bladeRF && git archive --format=tar --prefix=bladerf-$(VER)/  $(GITREV) | xz > ../bladerf_$(VER).orig.tar.xz
	rm -rf bladeRF

## bladerf 0.2014.09~rc2

=== fx3_firmware/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)

list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_LIST_DIR}/../host/cmake/modules)
set(VERSION_INFO_MAJOR 1)
set(VERSION_INFO_MINOR 7)
set(VERSION_INFO_PATCH 1)
if(NOT DEFINED VERSION_INFO_EXTRA)
    set(VERSION_INFO_EXTRA "git")
endif()
include(Version)

set(VERSION "${VERSION_INFO}")

# .dirstamp needs to touched before version.h so that fx3_firmware/makefile
# doesn't try to rebuild version.h.
configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/version.h.in
    ${CMAKE_CURRENT_BINARY_DIR}/build/.dirstamp
    @ONLY
)

configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/version.h.in
    ${CMAKE_CURRENT_BINARY_DIR}/build/version.h
    @ONLY
)

add_custom_target(fx3_firmware ALL
    COMMAND ${CMAKE_MAKE_PROGRAM} OUTPUT_DIR=${CMAKE_CURRENT_BINARY_DIR}/build
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})

set_directory_properties(PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES
    ${CMAKE_CURRENT_BINARY_DIR}/build)

=== host/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(bladeRF C)

################################################################################
# Project configuration
################################################################################

# All build output lands in this directory:
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/output)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/output)
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/output)

if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE "Release")
    message(STATUS "Build type not specified: defaulting to a release build.")
endif()

set(CMAKE_BUILD_TYPE ${CMAKE_BUILD_TYPE} CACHE STRING "Build type")
list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_LIST_DIR}/cmake/modules)

# Firmware <--> Host common files
set(BLADERF_FW_COMMON_INCLUDE_DIR ${CMAKE_CURRENT_LIST_DIR}/../firmware_common)

# Source and headers common amongst host software
set(BLADERF_HOST_COMMON_INCLUDE_DIRS
        ${CMAKE_CURRENT_LIST_DIR}/common/include
        ${CMAKE_CURRENT_BINARY_DIR}/common/include
)

set(BLADERF_HOST_COMMON_SOURCE_DIR ${CMAKE_CURRENT_LIST_DIR}/common/src)

###############################
# Misc. options
###############################
option(ENABLE_LOG_FILE_INFO
        "Enable source file and line number information in log messages."
        OFF)

option(BUILD_DOCUMENTATION
        "Enable build and install of manpages and other documentation."
        OFF)

option(TREAT_WARNINGS_AS_ERRORS
       "Treat compiler warnings as errors."
       ON)

if(ENABLE_LOG_FILE_INFO)
    add_definitions(-DLOG_INCLUDE_FILE_INFO)
endif()

################################################################################
# Configure host-specific items
################################################################################
include(TestBigEndian)
TEST_BIG_ENDIAN(BLADERF_BIG_ENDIAN)

# Test for libusb so warnings and such only occur at the top-level
# TODO Once we enable other backends, we should revisit whether this is a good
#      location for this
include(FindLibUSB)

configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/common/include/host_config.h.in
    ${CMAKE_CURRENT_BINARY_DIR}/common/include/host_config.h
    @ONLY
)

################################################################################
# Compiler configuration
################################################################################

###############################
# GCC
###############################
option(ENABLE_GDB_EXTENSIONS
       "When performing a debug build with GCC, this will enable -ggdb instead of -g"
       OFF)

if("${CMAKE_BUILD_TYPE}" STREQUAL "Debug" AND
   "${CMAKE_C_COMPILER_ID}" STREQUAL "GNU")

    # Personal preference - as much debug info as possible with GDB
    if(${ENABLE_GDB_EXTENSIONS})
        string(REGEX REPLACE "^-g$" "-ggdb3" CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG}")
    endif(${ENABLE_GDB_EXTENSIONS})

endif()

###############################
# GCC and Clang
###############################
if("${CMAKE_C_COMPILER_ID}" STREQUAL "GNU" OR
   "${CMAKE_C_COMPILER_ID}" STREQUAL "Clang")

    add_definitions(-Wall)
    add_definitions(-Wextra)
    add_definitions(-Wno-unused-parameter)

    if(TREAT_WARNINGS_AS_ERRORS)
        add_definitions(-Werror)
    endif()

    if("${CMAKE_BUILD_TYPE}" STREQUAL "Debug")
        add_definitions(-DDEBUG=1)
        add_definitions(-O0)
    endif("${CMAKE_BUILD_TYPE}" STREQUAL "Debug")

endif("${CMAKE_C_COMPILER_ID}" STREQUAL "GNU" OR
      "${CMAKE_C_COMPILER_ID}" STREQUAL "Clang")

###############################
# MS Visual Studio
###############################
if(MSVC)
    if(TREAT_WARNINGS_AS_ERRORS)
        set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /WX")
    endif()
endif(MSVC)

################################################################################
# System configuration
################################################################################

# Linux (TODO determine if this will actually be sufficient for BSD)
if(${CMAKE_SYSTEM_NAME} MATCHES "Linux" OR ${CMAKE_SYSTEM_NAME} MATCHES "BSD")
    set(BLADERF_OS_LINUX 1)

    try_run(LIBC_VERSION_RUN_RESULT LIBC_VERSION_COMPILE_RESULT
            ${CMAKE_CURRENT_BINARY_DIR}/cmake/helpers
            ${CMAKE_CURRENT_SOURCE_DIR}/cmake/helpers/libc_version.c
            RUN_OUTPUT_VARIABLE LIBC_VERSION)

    if(LIBC_VERSION)
        message(STATUS "libc version: ${LIBC_VERSION}")
    else()
        message(WARNING "Unable to determine libc version")
    endif()

elseif(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
    set(BLADERF_OS_OSX 1)

    # We also need to add some headers that the system will not provide
    set(BLADERF_HOST_COMMON_INCLUDE_DIRS
            ${BLADERF_HOST_COMMON_INCLUDE_DIRS}
            ${CMAKE_CURRENT_LIST_DIR}/common/include/osx
    )

elseif(${CMAKE_SYSTEM_NAME} MATCHES "Windows")
    set(BLADERF_OS_WINDOWS 1)

    # We also need to add some headers that the system will not provide
    set(BLADERF_HOST_COMMON_INCLUDE_DIRS
            ${BLADERF_HOST_COMMON_INCLUDE_DIRS}
            ${CMAKE_CURRENT_LIST_DIR}/common/include/windows
    )

    add_definitions(-D_CRT_SECURE_NO_WARNINGS)
else()
    message(FATAL_ERROR "Unsupported host operating system: ${CMAKE_SYSTEM_NAME}")
endif()

configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/common/include/host_config.h.in
    ${CMAKE_CURRENT_BINARY_DIR}/common/include/host_config.h
    @ONLY
)

# OSX
if(APPLE)
    set(CMAKE_MACOSX_RPATH ON)
    set(CMAKE_SKIP_BUILD_RPATH FALSE)
    set(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
    set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
    set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
    list(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${CMAKE_INSTALL_PREFIX}/lib" isSystemDir)
    if("${isSystemDir}" STREQUAL "-1")
        set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
    endif()
endif()

################################################################################
# Process subdirectories
################################################################################
add_subdirectory(libraries)
add_subdirectory(misc)
add_subdirectory(utilities)

################################################################################
# Create uninstall target
################################################################################
configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
    IMMEDIATE @ONLY)

add_custom_target(uninstall
    COMMAND
    ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake
)

################################################################################
# Windows-only, Post build: Copy libraries to our build output directory
################################################################################
if(WIN32)
    find_package(LibPThreadsWin32)
    if(LIBPTHREADSWIN32_FOUND)
        set(WIN_POSTBUILD_ITEMS ${WIN_POSTBUILD_ITEMS}
                "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}/${CMAKE_CFG_INTDIR}/pthreadVC2.dll")

        add_custom_command(
            OUTPUT "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}/${CMAKE_CFG_INTDIR}/pthreadVC2.dll"
            COMMAND ${CMAKE_COMMAND} -E copy_if_different
                "${LIBPTHREADSWIN32_PATH}/dll/${LIBPTHREADSWIN32_LIBRARY_PATH_SUFFIX}/pthreadVC2.dll"
                "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}/${CMAKE_CFG_INTDIR}/"
            COMMENT "Copying pthreadVC2.dll to output directory..."
        )
    endif(LIBPTHREADSWIN32_FOUND)

    if(LIBUSB_FOUND)
        set(WIN_POSTBUILD_ITEMS ${WIN_POSTBUILD_ITEMS}
            "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}/${CMAKE_CFG_INTDIR}/libusb-1.0.dll")

        add_custom_command(
            OUTPUT "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}/${CMAKE_CFG_INTDIR}/libusb-1.0.dll"
            COMMAND ${CMAKE_COMMAND} -E copy_if_different
                "${LIBUSB_PATH}/${LIBUSB_LIBRARY_PATH_SUFFIX}/libusb-1.0.dll"
                "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}/${CMAKE_CFG_INTDIR}/"
            COMMENT "Copying libusb-1.0.dll to output directory..."
        )
    endif(LIBUSB_FOUND)

    add_custom_target(win_postbuild ALL DEPENDS ${WIN_POSTBUILD_ITEMS})

endif(WIN32)

=== host/libraries/libbladeRF/CMakeLists.txt ===
--- 
+++ 
@@ -22,8 +22,8 @@
 ################################################################################
 
 set(VERSION_INFO_MAJOR  0)
-set(VERSION_INFO_MINOR  14)
-set(VERSION_INFO_PATCH  0)
+set(VERSION_INFO_MINOR  16)
+set(VERSION_INFO_PATCH  2)
 
 if(NOT DEFINED VERSION_INFO_EXTRA)
     set(VERSION_INFO_EXTRA "git")
@@ -69,14 +69,31 @@
     set(BUILD_LIBBLADERF_DOCUMENTATION OFF)
 endif()
 
+option(ENABLE_LIBBLADERF_SYNC
+    "Enable the libbladeRF synchronous data interface. Requires pthreads."
+    ${HAVE_THREADS}
+)
+
+option(ENABLE_LIBBLADERF_SYNC_LOG_VERBOSE
+      "Enable log_verbose() calls in the sync interface's data path. Note that this may harm performance."
+      OFF
+)
+
 ##############################
 # Backend Support
 ##############################
-option(ENABLE_BACKEND_LIBUSB "Enable libusb backend support."
+option(ENABLE_BACKEND_USB
+    "Enable USB backends. Required when using the bladeRF with a host machine."
     ON
 )
 
-option(ENABLE_BACKEND_DUMMY "Enable dummy backend support. This is only useful for some developers."
+option(ENABLE_BACKEND_LIBUSB
+    "Enable libusb backend support."
+    ON
+)
+
+option(ENABLE_BACKEND_DUMMY
+    "Enable dummy backend support. This is only useful for some developers."
     OFF
 )
 
@@ -85,21 +102,11 @@
     ON
 )
 
-option(ENABLE_LIBBLADERF_SYNC
-    "Enable the libbladeRF synchronous data interface. Requires pthreads."
-    ON
-)
-
-option(ENABLE_LIBBLADERF_SYNC_LOG_VERBOSE
-      "Enable log_verbose() calls in the sync interface's data path. Note that this may harm performance."
-      OFF
-)
-
-
 option(ENABLE_BACKEND_LINUX_DRIVER
     "Enable Linux driver backend support."
     OFF
 )
+
 
 # Ensure we've got at least one backend enabled
 if(NOT ENABLE_BACKEND_LIBUSB AND NOT ENABLE_BACKEND_LINUX_DRIVER AND NOT ENABLE_BACKEND_DUMMY)
@@ -109,8 +116,8 @@
 endif()
 
 configure_file(
-    ${CMAKE_CURRENT_SOURCE_DIR}/src/backend_config.h.in
-    ${CMAKE_CURRENT_BINARY_DIR}/src/backend_config.h
+    ${CMAKE_CURRENT_SOURCE_DIR}/src/backend/backend_config.h.in
+    ${CMAKE_CURRENT_BINARY_DIR}/src/backend/backend_config.h
     @ONLY
 )
 
@@ -148,6 +155,11 @@
 ################################################################################
 if(NOT HAVE_THREADS)
     message(FATAL_ERROR "Pthreads is required for libbladeRF")
+endif()
+
+if(NOT ENABLE_BACKEND_USB)
+    set(ENABLE_BACKEND_LIBUSB OFF)
+    set(ENABLE_BACKEND_LINUX_DRIVER OFF)
 endif()
 
 if(ENABLE_BACKEND_LIBUSB)
@@ -159,6 +171,10 @@
             add_definitions(-DHAVE_LIBUSB_GET_VERSION)
         endif(LIBUSB_HAVE_GET_VERSION)
 
+        if(NOT LIBUSB_HAVE_HANDLE_EVENTS_TIMEOUT)
+            MESSAGE(FATAL "The required function libusb_handle_events_timeout() is missing")
+        endif()
+
         set(LIBBLADERF_INCLUDES ${LIBBLADERF_INCLUDES} ${LIBUSB_INCLUDE_DIRS})
     endif(NOT LIBUSB_FOUND)
 endif(ENABLE_BACKEND_LIBUSB)
@@ -183,17 +199,21 @@
 ################################################################################
 set(LIBBLADERF_SOURCE
         src/async.c
-        src/backend.c
+        src/backend/backend.c
         src/bladerf.c
         src/bladerf_priv.c
+        src/config.c
+        src/dc_cal_table.c
         src/file_ops.c
         src/lms.c
         src/si5338.c
+        src/xb.c
         src/version.h
         src/device_identifier.c
         src/devinfo.c
         src/flash.c
         src/image.c
+        src/version_compat.c
         ${BLADERF_HOST_COMMON_SOURCE_DIR}/sha256.c
         ${BLADERF_HOST_COMMON_SOURCE_DIR}/conversions.c
         ${BLADERF_HOST_COMMON_SOURCE_DIR}/log.c
@@ -203,8 +223,12 @@
         set(LIBBLADERF_SOURCE ${LIBBLADERF_SOURCE} ${CMAKE_CURRENT_BINARY_DIR}/bladerf.rc)
 endif()
 
+if(ENABLE_BACKEND_USB)
+    set(LIBBLADERF_SOURCE ${LIBBLADERF_SOURCE} src/backend/usb/usb.c)
+endif()
+
 if(LIBUSB_FOUND AND ENABLE_BACKEND_LIBUSB)
-    set(LIBBLADERF_SOURCE ${LIBBLADERF_SOURCE} src/backend/libusb.c)
+    set(LIBBLADERF_SOURCE ${LIBBLADERF_SOURCE} src/backend//usb/libusb.c)
 endif()
 
 if(ENABLE_BACKEND_DUMMY)
@@ -347,4 +371,3 @@
     else(DOXYGEN_FOUND)
         message(WARNING "Could not find Doxygen. libbladeRF API documentation will not be built.")
     endif(DOXYGEN_FOUND)
-endif(BUILD_LIBBLADERF_DOCUMENTATION)

=== host/utilities/bladeRF-cli/CMakeLists.txt ===
--- 
+++ 
@@ -6,8 +6,8 @@
 ################################################################################
 
 set(VERSION_INFO_MAJOR  0)
-set(VERSION_INFO_MINOR  10)
-set(VERSION_INFO_PATCH  7)
+set(VERSION_INFO_MINOR  11)
+set(VERSION_INFO_PATCH  1)
 if(NOT DEFINED VERSION_INFO_EXTRA)
     set(VERSION_INFO_EXTRA "git")
 endif()
@@ -21,6 +21,32 @@
     @ONLY
 )
 
+################################################################################
+# Regenerate interactive help
+################################################################################
+file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/src/cmd/doc)
+find_program(PANDOC_EXECUTABLE pandoc)
+
+if(PANDOC_EXECUTABLE)
+    # Run the generation script
+    message(STATUS "Will use pandoc to generate interactive help")
+    add_custom_command(
+        OUTPUT src/cmd/doc/cmd_help.h src/cmd/doc/cmd_help.man
+        COMMAND bash ${CMAKE_CURRENT_SOURCE_DIR}/src/cmd/doc/generate.bash ${CMAKE_CURRENT_SOURCE_DIR}/src/cmd/doc/interactive-help.md
+        WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/src/cmd/doc
+    )
+else(PANDOC_EXECUTABLE)
+    # Re-use old cmd_help.h and cmd_help.man
+    message(STATUS "Could not find pandoc.  Interactive help may be out of date.")
+    add_custom_command(
+        OUTPUT src/cmd/doc/cmd_help.h
+        COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/src/cmd/doc/cmd_help.h.in ${CMAKE_CURRENT_BINARY_DIR}/src/cmd/doc/cmd_help.h
+    )
+    add_custom_command(
+        OUTPUT src/cmd/doc/cmd_help.man
+        COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/src/cmd/doc/cmd_help.man.in ${CMAKE_CURRENT_BINARY_DIR}/src/cmd/doc/cmd_help.man
+    )
+endif(PANDOC_EXECUTABLE)
 ################################################################################
 # Build dependencies
 ################################################################################
@@ -43,7 +69,7 @@
 )
 
 option(BUILD_BLADERF_CLI_DOCUMENTATION
-        "Build bladeRF-cli man page. Requires help2man and python."
+        "Build bladeRF-cli man page. Requires help2man."
         ${BUILD_DOCUMENTATION})
 
 if(NOT ${BUILD_DOCUMENTATION})
@@ -61,8 +87,9 @@
 set(CLI_INCLUDE_DIRS
        ${CMAKE_CURRENT_SOURCE_DIR}/src
        ${CMAKE_CURRENT_SOURCE_DIR}/src/cmd
-       ${CMAKE_CURRENT_SOURCE_DIR}/src/interactive
+       ${CMAKE_CURRENT_SOURCE_DIR}/src/input
        ${CMAKE_CURRENT_BINARY_DIR}/src
+       ${CMAKE_CURRENT_BINARY_DIR}/src/cmd
        ${BLADERF_HOST_COMMON_INCLUDE_DIRS}
        ${libbladeRF_SOURCE_DIR}/include
        ${BLADERF_FW_COMMON_INCLUDE_DIR}
@@ -99,8 +126,9 @@
 set(BLADERF_CLI_SOURCE
         src/main.c
         src/common.c
-        src/script.c
         src/cmd/calibrate.c
+        src/cmd/calibrate_dc.c
+        src/cmd/doc/cmd_help.h
         src/cmd/cmd.c
         src/cmd/erase.c
         src/cmd/flash_common.c
@@ -112,20 +140,23 @@
         src/cmd/load.c
         src/cmd/open.c
         src/cmd/peek.c
+        src/cmd/lms_reg_info.c
         src/cmd/peekpoke.c
         src/cmd/poke.c
         src/cmd/printset.c
         src/cmd/probe.c
+        src/cmd/xb.c
         src/cmd/rx.c
         src/cmd/rxtx.c
         src/cmd/tx.c
         src/cmd/version.c
         src/cmd/jump_boot.c
         src/cmd/mimo.c
-        src/cmd/correct.c
-        src/interactive/interactive.c
+        src/input/input.c
+        src/input/script.c
         ${BLADERF_HOST_COMMON_SOURCE_DIR}/conversions.c
         ${BLADERF_HOST_COMMON_SOURCE_DIR}/log.c
+        ${BLADERF_HOST_COMMON_SOURCE_DIR}/str_queue.c
 )
 
 if(LIBUSB_FOUND)
@@ -135,11 +166,11 @@
 )
 endif()
 
-# Select the interactive mode (and script handling) backend
-if(ENABLE_LIBTECLA)
-    set(BLADERF_CLI_SOURCE ${BLADERF_CLI_SOURCE} src/interactive/tecla.c)
+# Select the input mode (and script handling) backend
+if(ENABLE_LIBTECLA)
+    set(BLADERF_CLI_SOURCE ${BLADERF_CLI_SOURCE} src/input/tecla.c)
 else()
-    set(BLADERF_CLI_SOURCE ${BLADERF_CLI_SOURCE} src/interactive/fgets.c)
+    set(BLADERF_CLI_SOURCE ${BLADERF_CLI_SOURCE} src/input/fgets.c)
 endif()
 
 if(MSVC)
@@ -164,6 +195,10 @@
     libbladerf_shared
     ${CMAKE_THREAD_LIBS_INIT}
 )
+
+if(NOT MSVC)
+    set(CLI_LINK_LIBRARIES ${CLI_LINK_LIBRARIES} m)
+endif()
 
 if(ENABLE_LIBTECLA)
     set(CLI_LINK_LIBRARIES ${CLI_LINK_LIBRARIES} ${LIBTECLA_LIBRARIES})
@@ -207,22 +242,13 @@
             set(MAN_INSTALL_DIR share/man)
         endif(NOT DEFINED MAN_INSTALL_DIR)
 
-        # Build interactive commands summary, for inclusion in man page
-        add_custom_command(
-            OUTPUT bladeRF-cli_auto.h2m
-            DEPENDS bladeRF-cli
-            COMMAND python ${CMAKE_CURRENT_SOURCE_DIR}/../doc/include_man/interrogate.py
-                           ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/bladeRF-cli > bladeRF-cli_auto.h2m
-            WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
-        )
-
         # Build actual man page
         add_custom_command(
             OUTPUT bladeRF-cli.1
-            DEPENDS bladeRF-cli bladeRF-cli_auto.h2m
+            DEPENDS bladeRF-cli src/cmd/doc/cmd_help.man
             COMMAND ${HELP2MAN_EXECUTABLE} --no-info
                                            --opt-include=${CMAKE_CURRENT_SOURCE_DIR}/../doc/include_man/bladeRF-cli.h2m
-                                           --opt-include=${CMAKE_CURRENT_BINARY_DIR}/bladeRF-cli_auto.h2m
+                                           --opt-include=${CMAKE_CURRENT_BINARY_DIR}/src/cmd/doc/cmd_help.man
                                            --opt-include=${CMAKE_CURRENT_SOURCE_DIR}/../doc/include_man/common.h2m
                                            --output=bladeRF-cli.1 ./bladeRF-cli
             WORKING_DIRECTORY ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}

=== debian/changelog ===
bladerf (0.2014.09~rc2-5) unstable; urgency=low

  * remove kfreebsd uninstallable dependency on libusb-1.0-0 

 -- A. Maitland Bottoms <bottoms@debian.org>  Fri, 12 Sep 2014 09:40:21 -0400

bladerf (0.2014.09~rc2-4) unstable; urgency=low

  * update build dependency to libtecla-dev (due to libtecla 1.6.2)

 -- A. Maitland Bottoms <bottoms@debian.org>  Tue, 09 Sep 2014 14:49:14 -0400

bladerf (0.2014.09~rc2-3) unstable; urgency=low

  * update usb library dependencies

 -- A. Maitland Bottoms <bottoms@debian.org>  Tue, 09 Sep 2014 01:27:32 -0400

bladerf (0.2014.09~rc2-2) unstable; urgency=low

  * Update to 2014.09-rc2-49-g0bb0cce

 -- A. Maitland Bottoms <bottoms@debian.org>  Wed, 27 Aug 2014 02:37:36 -0400

bladerf (0.2014.09~rc2-1) unstable; urgency=low

  * Update to 2014.09-rc2-39g0189d48
    bladeRF-install-firmware checksums updated
  * Second of three release candidates for 2014.09 release
  * FPGA bitstream v0.0.6,
    FX3 Firmware v1.7.1,
    libbladeRF v0.16.2, bladeRF-cli v0.11.1
  * [hdl (nios)] Defects present in gain/phase correction bug
  * Frequency readback is incorrect when using xb200 bug
  * Markdown-ify the bladeRF-cli interactive help
  * bladeRF-cli: Clean up print/set lnagain bug
  * [libbladeRF] LMS VTUNE not locking occasionally bug
  * [bladeRF-Cli] Fix 'correct' command parameter ranges, cleanup usage and
    help text
  * [libbladeRF] Remove bladerf_* calls from lms.c enhancement
  * [libbladeRF] Cleanup: Move bladerf_get/set_sampling to lms.c enhancement
  * libbladeRF: LMS SELOUT[1:0] may be left in an invalid state upon exiting
    loopback mode
  * [CLI] After a calibrate command is issued, the bladeRF transmits a carrier

 -- A. Maitland Bottoms <bottoms@debian.org>  Wed, 20 Aug 2014 11:23:42 -0400

bladerf (0.2014.09~rc1-1) unstable; urgency=low

  * New upstream release candidate
  
 -- A. Maitland Bottoms <bottoms@debian.org>  Sun, 06 Jul 2014 23:06:53 -0400

=== debian/control ===
Source: bladerf
Priority: extra
Maintainer: A. Maitland Bottoms <bottoms@debian.org>
Build-Depends: debhelper (>=9), cmake (>= 2.8.5), pkg-config, doxygen,
 libusb-1.0-0-dev (>= 1.0.12) [linux-any], libusb2-dev [kfreebsd-any],
 libtecla-dev, libncurses5-dev, help2man
Standards-Version: 3.9.5
Section: comm
Homepage: http://www.nuand.com/bladeRF
Vcs-Git: git://github.com/Nuand/bladeRF.git
Vcs-Browser: https://github.com/Nuand/bladeRF

Package: libbladerf0
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: nuand bladeRF software-defined radio device
 The nuand bladeRF is an open-source software-defined radio (SDR) system,
 comprised of an RF transceiver, a field-programmable gate array (FPGA),
 a microcontroller driving a USB 3.0 interface, and a suite of host
 libraries and drivers to facilitate interaction with the device.
 .
 This package provides the host library.

Package: libbladerf-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libbladerf0 (= ${binary:Version}), libc6-dev | libc-dev, ${misc:Depends}
Replaces: libbladerf0-dev (<< 0.11.0+1SNAPSHOT20131229)
Breaks: libbladerf0-dev (<< 0.11.0+1SNAPSHOT20131229)
Description: nuand bladeRF software-defined radio device (header files)
 The nuand bladeRF is an open-source software-defined radio (SDR) system,
 comprised of an RF transceiver, a field-programmable gate array (FPGA),
 a microcontroller driving a USB 3.0 interface, and a suite of host
 libraries and drivers to facilitate interaction with the device.
 .
 This package contains the header files required for compiling bladeRF
 applications.

Package: bladerf
Section: comm
Architecture: any
Multi-Arch: foreign
Depends: libbladerf0 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: nuand bladeRF software-defined radio device (tools)
 The nuand bladeRF is an open-source software-defined radio (SDR) system,
 comprised of an RF transceiver, a field-programmable gate array (FPGA),
 a microcontroller driving a USB 3.0 interface, and a suite of host
 libraries and drivers to facilitate interaction with the device.
 .
 This package provides command-line tools for controlling the bladeRF.
